# CNN/Slashdot/Freshmeat news.tcl V2.0
# Original idea by Thrill
# Rewritten by CyBot
# 
# All newsheadlines parsed by this script are (C) cnn.com respectively slashdot.org respectively freshmeat.net
# 
# Version History: V1.0  - first public release
#                  V1.01 - stupid bug ('putchan') fixed
#                  V1.1  - added URL's to the newsitem.
#                  V2.0  - Complete rewrite by CyBot:
#                          don't need temp-files anymore,
#                          added slashdot and freshmeat headlines
#
# The authors take no responsibility whatsoever for the usage and working of this script!
# 
# Thrill's E-mail: jmildham59@hotmail.com
# CyBot's  E-mail: cybot@cyberdude.com (or on IRC: CyBot @ irc.newnet.net)

#### Configuration ####

# The Prefix for the news query. Default is !news
set cmdchar "!"

# Set the location of lynx here. Normally this should be ok. If unsure, try to execute "which lynx"
set lynx "/usr/bin/lynx"

# If you change this to "yes", the script will use mIRC-style colours to hide most ofthe url by making the text white.
# That way your screen won't look to cluttered up, but you can still doubleclick on the URLs. (at least in mIRC)
set col "no"

#### DO NOT EDIT BELOW - EVERY CHANGE IS ON YOUR OWN RISK AND COULD LEAD THIS SCRIPT TO FAIL! ####

#command binding
bind pub - [string trim $cmdchar]news news

#define all strings here
set topstories    "TOP STORIES"
set world         "WORLD"
set us            "US"
set politics      "POLITICS"
set weather       "WEATHER"
set business      "BUSINESS from CNNfn.com"
set sports        "SPORTS from CNNSI.com"
set technology    "TECHNOLOGY"
set space         "SPACE"
set health        "HEALTH"
set entertainment "ENTERTAINMENT"
set travel        "TRAVEL"

################
# Function: news
# Purpose : public function called by the bind !news, selects user-choice and forwards to a news-parsing function
proc news {nick uhost handle chan arg} {
	global topstories world us politics weather business sports technology space health entertainment travel cmdchar
	if {[llength $arg] == 0} {
		putserv "PRIVMSG $chan :Please enter which news you would like to read ([string trim $cmdchar]news list)"
	} else {
		switch [string tolower [lindex $arg 0]] {
			"list" {
				puthelp "notice $nick :CNN/SlashDot/Freshmeat News v2.0 - www.cnn.com / slashdot.org / freshmeat.net"
				puthelp "notice $nick :Usage: [string trim $cmdchar]news <item>"
				puthelp "notice $nick :where <item> is one of the following:"
				puthelp "notice $nick :\002top\002       - Top Stories     \002world\002     - World News"
				puthelp "notice $nick :\002us\002        - US News         \002politics\002  - Politics News"
				puthelp "notice $nick :\002weather\002   - Weather News    \002business\002  - Business News"
				puthelp "notice $nick :\002tech\002      - Technology News \002space\002     - Space News"
				puthelp "notice $nick :\002health\002    - Health News     \002entertain\002 - Entertainment News"
				puthelp "notice $nick :\002sports\002    - Sports News     \002travel\002    - Travel News"
				puthelp "notice $nick :\002slashdot\002  - /. Headlines    \002freshmeat\002 - Freshmeat Releases"
			}
			"top" {
				getcnn
				putchan $chan "CNN \002Top Stories\002 Headlines (c) CNN.com"
				parsecnn $chan $topstories
			}
			"world" {
				getcnn
				putchan $chan "CNN \002World News\002 Headlines (c) CNN.com"
				parsecnn $chan $world
			}
			"us" {
				getcnn
				putchan $chan "CNN \002US\002 Headlines (c) CNN.com"
				parsecnn $chan $us
			}
			"politics" {
				getcnn
				putchan $chan "CNN \002Politics\002 Headlines (c) CNN.com"
				parsecnn $chan $politics
			}
			"weather" {
				getcnn
				putchan $chan "CNN \002Weather\002 Headlines (c) CNN.com"
				parsecnn $chan $weather
			}
			"business" {
				getcnn
				putchan $chan "CNN \002Business\002 Headlines (c) CNN.com"
				parsecnn $chan $business
			}
			"tech" {
				getcnn
				putchan $chan "CNN \002Technology\002 Headlines (c) CNN.com"
				parsecnn $chan $technology
			}
			"space" {
				getcnn
				putchan $chan "CNN \002Space\002 Headlines (c) CNN.com"
				parsecnn $chan $space
			}
			"health" {
				getcnn
				putchan $chan "CNN \002Health\002 Headlines (c) CNN.com"
				parsecnn $chan $health
			}
			"entertain" {
				getcnn
				putchan $chan "CNN \002Entertainment\002 Headlines (c) CNN.com"
				parsecnn $chan $entertainment
			}
			"sports" {
				getcnn
				putchan $chan "CNN \002Sports\002 Headlines (c) CNN.com"
				parsecnn $chan $sports
			}
			"travel" {
				getcnn
				putchan $chan "CNN \002Travel\002 Headlines (c) CNN.com"
				parsecnn $chan $travel
			}
			"/."
				-
			"slashdot" {
				putchan $chan "\002SlashDot\002 Headlines (c) slashdot.org"
				getslash $chan "slashdot.org/slashdot.xml"
			}
			"fm"
				-
			"freshmeat" {
				putchan $chan "\002Freshmeat\002 Recent Releases (c) freshmeat.net"
				getfm $chan "http://freshmeat.net/backend/recentnews.txt"
			}
			default { 
				# user pasted some weird other string after !news ... ; fetch default Top Stories
				getcnn
				putchan $chan "CNN \002Top Stories\002 Headlines (c) CNN.com - \002\"[string trim $cmdchar]news list\" for valid options\002"
				parsecnn $chan $topstories
			}
		}
	}
}

################
# Function: getcnn
# Purpose : private function which acquires the news from www.cnn.com and parses it into a list and an array
#           the first containing the headlines, the second the URL-references
proc getcnn {} {
	global lynx thenews references
	set fnews [open "|$lynx -preparsed -dump www.cnn.com/desktop/content.html" r]
	while {![eof $fnews]} {
		# put top of file into thenews list
		set line [gets $fnews]
		if {[string first "References" $line] != -1} {
			break
		}
		lappend thenews $line
	}
	array set references {}
	set i 0
	while {![eof $fnews]} {
		# put references in references array
		set line [string range [gets $fnews] 6 end]
		set references($i) $line
		incr i
	}
	close $fnews
}

################
# Function: parsecnn
# Purpose : private function which generates the output out of the news list and the url array
proc parsecnn {chan arg} {
	global thenews references
	set i [lsearch -glob $thenews "*$arg*"]
	if {$i == -1} {
		putlog "CNN News Site has changed! $arg not found"
		putchan $chan "CNN News site seems to have changed, sorry"
		return 0
	}
	#skip two lines
	incr i 2
	foreach line [lrange $thenews $i end] {
		if {[string length $line] < 5} {
			#no more headlines
			break
		}
		#now get the reference number
		set i [string first "* \[" $line]
		set j [string first "\]" $line $i]
		if {$i == -1 || $j == -1} {
			putlog "CNN News site has changed! (or lynx?)"
			putchan $chan "CNN News site seems to have changed, sorry"
			return 0
		}
		set i [string range $line [expr $i + 3] [expr $j - 1]]
		putchan $chan [string range $line [expr $j + 1] end] $references($i)
	}
	unset thenews
	unset references
}

################
# Function: getslash
# Purpose : private function which acquires the news from slashdot.org, parses them and generates the output
proc getslash {chan xml} {
	global lynx
	set fnews [open "|$lynx -dump $xml" r]
	while {![eof $fnews]} {
		set line [gets $fnews]
		set i [string first "<title>" $line]
		if {$i != -1} {
			set j [string last "</title>" $line]
			set headline [string range $line [expr $i + 7] [expr $j - 1]]
		} else {
			set i [string first "<url>" $line]
			if {$i != -1} {
				set j [string last "</url>" $line]
				putchan $chan $headline [string range $line [expr $i + 5] [expr $j - 1]]
			}
		}
	}
	close $fnews
}

################
# Function: getfm
# Purpose : private function which acquires the news from freshmeat.net, parses them and generates the output
proc getfm {chan txt} {
	global lynx
	set fnews [open "|$lynx -dump $txt" r]
	while {![eof $fnews]} {
		set headline [gets $fnews]
		if {[eof $fnews]} {
			if {[string trim $headline] == ""} {
				close $fnews
				return 0
			}
			putlog "Freshmeat site has changed! ($headline)"
			putchan $chan "Freshmeat site seems to have changed, sorry"
			return 0
		}
		gets $fnews
		if {[eof $fnews]} {
			if {[string trim $headline] == ""} {
				close $fnews
				return 0
			}
			putlog "Freshmeat site has changed! ($headline)"
			putchan $chan "Freshmeat site seems to have changed, sorry"
			return 0
		}
		putchan $chan $headline [gets $fnews]
	}
	close $fnews
}

proc putchan {chan headline {url ""}} {
	global col
	if {$url == ""} {
		putserv "PRIVMSG $chan :$headline"
	} else {
		if {$col == "yes"} {
			putserv "PRIVMSG $chan :4 $headline 5Click: [string range $url 0 [expr [string first "/" $url 7] - 1]]0[string range $url [string first "/" $url 7] end]"
		} else {
			putserv "PRIVMSG $chan : $headline ($url)"
		}
	}
}

putlog "News v2.0 by CyBot - Loaded."
